﻿using System;
using System.Linq;

namespace VsliveOrd.Api
{
    public class PersonService
    {
        private IPersonRepository _Repository;
        private IPersonValidatorStrategy _Validator;

        public PersonService(IPersonRepository repository,
            IPersonValidatorStrategy validator)
        {
            if (repository == null)
            {
                throw new ArgumentNullException(nameof(repository), $"{nameof(repository)} is null.");
            }
            _Validator = validator;
            // _Repository = new ReallyHardToConstructPersonRepository();
            _Repository = repository;
        }


        public void Save(Person saveThis)
        {
            try
            {
                if (_Validator.IsValid(saveThis) == true)
                {
                    ActuallySave(saveThis);
                }
                else
                {
                    throw new InvalidOperationException("Argument cannot be null.");
                }
            }
            catch(SqlServerOutOfDiskSpaceException)
            {
                SaveTheWorld();
            }
        }

        private void SaveTheWorld()
        {
            throw new NotImplementedException();
        }

        private void ActuallySave(Person saveThis)
        {
            _Repository.Save(saveThis);
        }
    }
}
